package com.hncy.auth.inject.spring.boot.starter.auth;

import java.util.Arrays;
import java.util.Optional;

/**
 * @Author: ying.dong
 * @Date: 2021/4/20 16:31
 */
public enum AccTypeEnum {

    USER_OPT(1, "admin"), USER_PATIENT(2, "patient"),
    USER_DOCTOR(3, "doctor"), USER_SELLER(4, "seller");

    private int type;
    private String role;

    AccTypeEnum(int type, String role) {
        this.type = type;
        this.role = role;
    }

    public static Optional<AccTypeEnum> valueOf(int type) {
        return Arrays.stream(AccTypeEnum.values())
                .filter(it -> it.getType() == type)
                .findAny();

    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }

    public String getRole() {
        return role;
    }

    public void setRole(String role) {
        this.role = role;
    }
}
