package com.hncy.auth.inject.spring.boot.starter.auth;

import java.io.Serializable;

/**
 * 抽象认证通过的用户信息
 * @Author: ying.dong
 * @Date: 2021/4/20 16:40
 */
public abstract class AuthUser implements Serializable {

    private static final long serialVersionUID = 7382922674428433003L;

    /**
     * 系统ID (例： 医生通过短信登录，则account为doctorId）
     */
    protected final String account;

    /**
     * 登录所用的账号（例： 医生通过短信登录，则loginAccount为手机号）
     */
    protected final String loginAccount;

    public AuthUser(String account, String loginAccount) {
        this.account = account;
        this.loginAccount = loginAccount;
    }

    /**
     * 获取账号
     * @return
     */
    public String getAccount() {
        return account;
    }

    /**
     * 获取账号类型
     * @return
     */
    public abstract AccTypeEnum getAccType();

}
