package com.hncy.auth.inject.spring.boot.starter.common.factory;

import com.hncy.auth.inject.spring.boot.starter.auth.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.lang.NonNull;

/**
 * @Author: ying.dong
 * @Date: 2021/7/17 11:14
 */
@Slf4j
public class DefaultAuthUserFactory implements AuthUserFactory {

    @Override
    public AuthUser getAuthUser(@NonNull AccTypeEnum accTypeEnum, @NonNull String account, @NonNull String loginAccount) {
        AuthUser authUser = null;
        switch (accTypeEnum) {
            case USER_OPT:
                authUser = new OptAuthUser(account, loginAccount);
                break;
            case USER_DOCTOR:
                authUser = new DoctorAuthUser(account, loginAccount);
                break;
            case USER_PATIENT:
                authUser = new PatientAuthUser(account, loginAccount);
                break;
            case USER_SELLER:
                authUser = new SellerAuthUser(account, loginAccount);
                break;
        }
        return authUser;
    }
}
