package com.hncy.exception.handler.spring.boot.starter.core.translator.translators;

import com.hncy.common.exception.common.GlobalErrorConstants;
import com.hncy.common.exception.custom.BaseBusinessException;
import com.hncy.exception.handler.spring.boot.starter.common.ApiResult;
import com.hncy.exception.handler.spring.boot.starter.common.ApiResultBuilder;
import com.hncy.exception.handler.spring.boot.starter.core.translator.base.AbstractExceptionTranslator;
import org.springframework.http.HttpStatus;

/**
 * @Author: ying.dong
 * @Date: 2021/4/19 16:24
 */
public class CommonBusinessExceptionTranslator extends AbstractExceptionTranslator {

    @Override
    protected ApiResult doTranslate(Throwable throwable) {
        return ApiResultBuilder.build(GlobalErrorConstants.INTERNAL_SERVER_ERROR.getCode(), throwable.getMessage(), HttpStatus.INTERNAL_SERVER_ERROR);
    }

    @Override
    public boolean support(Throwable throwable) {
        return throwable instanceof BaseBusinessException;
    }
}
