package com.hncy.exception.handler.spring.boot.starter.core.translator.translators.webmvc;

import com.hncy.common.exception.common.GlobalErrorConstants;
import com.hncy.exception.handler.spring.boot.starter.common.ApiResult;
import com.hncy.exception.handler.spring.boot.starter.common.ApiResultBuilder;
import com.hncy.exception.handler.spring.boot.starter.core.translator.base.AbstractExceptionTranslator;
import org.springframework.http.HttpStatus;
import org.springframework.web.HttpRequestMethodNotSupportedException;

/**
 * @Author: ying.dong
 * @Date: 2021/4/19 16:24
 */
public class HttpMethodNotSupportedExceptionTranslator extends AbstractExceptionTranslator {

    @Override
    protected ApiResult doTranslate(Throwable throwable) {
        return ApiResultBuilder.build(GlobalErrorConstants.METHOD_NOT_ALLOWED.getCode(), GlobalErrorConstants.METHOD_NOT_ALLOWED.getMessage(), HttpStatus.METHOD_NOT_ALLOWED);
    }

    @Override
    public boolean support(Throwable throwable) {
        return throwable instanceof HttpRequestMethodNotSupportedException;
    }
}
