package com.hncy.exception.handler.spring.boot.starter.core.translator.translators.webmvc;

import com.hncy.common.exception.common.GlobalErrorConstants;
import com.hncy.exception.handler.spring.boot.starter.common.ApiResult;
import com.hncy.exception.handler.spring.boot.starter.common.ApiResultBuilder;
import com.hncy.exception.handler.spring.boot.starter.core.translator.base.AbstractExceptionTranslator;
import org.springframework.http.HttpStatus;
import org.springframework.web.servlet.NoHandlerFoundException;

/**
 * @Author: ying.dong
 * @Date: 2021/4/19 16:24
 */
public class NoHandlerFoundExceptionTranslator extends AbstractExceptionTranslator {

    @Override
    protected ApiResult doTranslate(Throwable throwable) {
        return ApiResultBuilder.build(GlobalErrorConstants.NOT_FOUND.getCode(), throwable.getMessage(), HttpStatus.NOT_FOUND);
    }

    @Override
    public boolean support(Throwable throwable) {
        return throwable instanceof NoHandlerFoundException;
    }
}
