package com.hncy.exception.handler.spring.boot.starter.core.translator.translators.webmvc;

import com.hncy.common.exception.custom.RequestNotMappingException;
import com.hncy.exception.handler.spring.boot.starter.common.ApiResult;
import com.hncy.exception.handler.spring.boot.starter.common.ApiResultBuilder;
import com.hncy.exception.handler.spring.boot.starter.core.translator.base.AbstractExceptionTranslator;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.HttpStatus;

/**
 * @Author: ying.dong
 * @Date: 2021/4/19 16:24
 */
@Slf4j
public class RequestNotMappingExceptionTranslator extends AbstractExceptionTranslator {

    @Override
    protected ApiResult doTranslate(Throwable throwable) {
        RequestNotMappingException t = (RequestNotMappingException) throwable;
        log.error("cannot mapping {}.", t.getUrl());
        return ApiResultBuilder.build(t.getCode(), "非法请求: " + t.getUrl(), HttpStatus.NOT_FOUND);
    }

    @Override
    public boolean support(Throwable throwable) {
        return throwable instanceof RequestNotMappingException;
    }
}
