package com.hncy.exception.handler.spring.boot.starter.core.translator.translators.webmvc;

import com.hncy.common.exception.common.GlobalErrorConstants;
import com.hncy.exception.handler.spring.boot.starter.common.ApiResult;
import com.hncy.exception.handler.spring.boot.starter.common.ApiResultBuilder;
import com.hncy.exception.handler.spring.boot.starter.core.translator.base.AbstractExceptionTranslator;
import org.springframework.context.support.DefaultMessageSourceResolvable;
import org.springframework.http.HttpStatus;
import org.springframework.validation.BindException;

import java.util.Optional;

/**
 * @Author: ying.dong
 * @Date: 2021/4/19 16:24
 */
public class WebBindingExceptionTranslator extends AbstractExceptionTranslator {

    @Override
    protected ApiResult doTranslate(Throwable throwable) {
        BindException e = (BindException) throwable;
        String bindingResult = Optional.ofNullable(e.getBindingResult().getFieldError())
                .map(DefaultMessageSourceResolvable::getDefaultMessage)
                .orElse(e.getLocalizedMessage());
        return ApiResultBuilder.build(GlobalErrorConstants.BAD_REQUEST.getCode(), bindingResult, HttpStatus.BAD_REQUEST);
    }

    @Override
    public boolean support(Throwable throwable) {
        return throwable instanceof BindException;
    }
}
