package com.hncy.exception.handler.spring.boot.starter.handler;

import com.hncy.exception.handler.spring.boot.starter.common.LocalResult;
import com.hncy.exception.handler.spring.boot.starter.core.translator.base.ExceptionTranslator;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestControllerAdvice;

/**
 * @Author: ying.dong
 * @Date: 2021/4/19 16:24
 */
@RestControllerAdvice
public class GlobalExceptionHandler {

    private final ExceptionTranslator exceptionTranslator;

    public GlobalExceptionHandler(ExceptionTranslator exceptionTranslator) {
        this.exceptionTranslator = exceptionTranslator;
    }

    @ExceptionHandler(Exception.class)
    public ResponseEntity<LocalResult> handleException(Exception e) {
        return exceptionTranslator.translate(e).toResponseEntity();
    }

}
