package com.hncy.feign.spring.boot.starter.exception;

import com.hncy.exception.handler.spring.boot.starter.common.ApiResult;
import com.hncy.exception.handler.spring.boot.starter.common.ApiResultBuilder;
import com.hncy.exception.handler.spring.boot.starter.core.translator.base.AbstractExceptionTranslator;
import org.springframework.http.HttpStatus;

/**
 * @Author: ying.dong
 * @Date: 2021/6/11 14:41
 */
public class RPCExceptionTranslator extends AbstractExceptionTranslator {

    @Override
    protected ApiResult doTranslate(Throwable throwable) {
        RPCException rpcException = (RPCException) throwable;
        return ApiResultBuilder.build(rpcException.getCode(), rpcException.getMessage(), HttpStatus.valueOf(rpcException.getStatus()));
    }

    @Override
    public boolean support(Throwable throwable) {
        return throwable instanceof RPCException;
    }
}
