package com.hncy.file.manage.spring.boot.starter.core.properties;

import lombok.Data;

/**
 * @Author: ying.dong
 * @Date: 2021/5/24 18:11
 */
@Data
public class CloudResourceProperties implements ResourceProperties {

    private final int DEFAULT_EXPIRED_IN_SECONDS = 1200;

    /**
     * oss bucket
     */
    private String bucket;

    /**
     * oss directory
     */
    private String directory;

    private String accessKey;

    private String accessSecret;

    private String endpoint;

    /**
     * 是否拥有读权限
     */
    private Boolean readable;

    /**
     * 是否拥有写权限
     */
    private Boolean writeable;

    /**
     * 签名有效期
     */
    private Integer expiredInTimeSeconds = DEFAULT_EXPIRED_IN_SECONDS;
}
