package com.hncy.file.manage.spring.boot.starter.core.resource;

import lombok.Data;
import org.springframework.lang.NonNull;
import org.springframework.lang.Nullable;

import java.net.URL;
import java.util.Map;

/**
 * @Author: ying.dong
 * @Date: 2021/5/24 15:04
 */
@Data
public abstract class CloudResource implements IResource {

    /**
     * bucket name
     */
    @Nullable
    private String bucket;

    /**
     * directory
     */
    @Nullable
    private String directory;

    /**
     * file name
     */
    @NonNull
    private String name;

    /**
     * MD5 digest (Base64)
     * 当指定为上传时，此参数不能为空
     */
    @Nullable
    private String MD5;

    @Nullable
    private Map<String, String> headers;

    /**
     * 最终生成的签名URL
     */
    @Nullable
    private URL url;
}
