package com.hncy.mybatis.spring.boot.starter;

import com.hncy.auth.inject.spring.boot.starter.auth.AuthUser;
import com.hncy.auth.inject.spring.boot.starter.holder.AuthUserHolder;
import com.hncy.mybatis.spring.boot.starter.handler.MetaHandler;
import org.springframework.boot.autoconfigure.condition.ConditionalOnClass;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @author xuy
 * @date 25/06/2021.
 */
@Configuration
public class MybatisPlusAutoConfiguration {


    @Configuration
    @ConditionalOnClass({AuthUser.class})
    static class MetaDataHandlerConfiguration {

        @Bean
        @ConditionalOnMissingBean
        public MetaHandler metaHandler (AuthUserHolder authUserHolder){
            return new MetaHandler(authUserHolder);
        }
    }
}
