package com.hncy.pageable.spring.boot.starter.core;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;
import lombok.extern.slf4j.Slf4j;

import java.util.List;

/**
 * @Author: ying.dong
 * @Date: 2021/5/6 14:50
 */
@Data
@ToString(callSuper = true)
@EqualsAndHashCode(callSuper = false)
@Slf4j
public class Page<E> extends PageInfo<E> {

    public Page(List<E> list) {
        super(list);
    }


    public Page() {
        super();
    }

    public static<E> Page<E> doSelectPage(ISelect<E> iSelect) {
        if (PageContext.getPageNum().isPresent() && PageContext.getPageSize().isPresent()) {
            Integer pageNum = PageContext.getPageNum().get();
            Integer pageSize = PageContext.getPageSize().get();
            log.debug("do select page, pageNum:{}, pageSize:{}", pageNum, pageSize);
            PageHelper.startPage(pageNum, pageSize);
        }
        return new Page<>(iSelect.doSelect());
    }
}
