package com.hncy.sentinel.spring.boot.starter;

import com.alibaba.csp.sentinel.adapter.gateway.zuul.fallback.BlockResponse;
import com.alibaba.csp.sentinel.adapter.gateway.zuul.fallback.ZuulBlockFallbackProvider;
import com.hncy.sentinel.spring.boot.starter.message.ResponseMessage;

/**
 * @Author: ying.dong
 * @Date: 2021/7/5 16:30
 */
public class CommonZuulBlockFallbackProvider implements ZuulBlockFallbackProvider {

    private final ResponseMessage blockMessage;

    public CommonZuulBlockFallbackProvider(ResponseMessage blockMessage) {
        this.blockMessage = blockMessage;
    }

    @Override
    public String getRoute() {
        return "*";
    }

    @Override
    public BlockResponse fallbackResponse(String route, Throwable cause) {
        return new BlockResponse(blockMessage.getCode(), blockMessage.getMessage(), route);
    }
}
