package com.hncy.sms.spring.boot.starter.aliyun.client;

import com.hncy.sms.spring.boot.starter.aliyun.client.config.AliyunClientConfiguration;
import com.hncy.sms.spring.boot.starter.aliyun.request.AliyunSmsSendRequest;
import com.hncy.sms.spring.boot.starter.aliyun.response.AliyunSmsSendResponse;
import com.hncy.sms.spring.boot.starter.constant.SmsConstant;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.cloud.openfeign.SpringQueryMap;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.PostMapping;

/**
 * @Author: ying.dong
 * @Date: 2021/5/11 15:26
 */
@FeignClient(name = "aliyunClient", url = SmsConstant.Domain.ALIYUN,
        configuration = AliyunClientConfiguration.class)
public interface AliyunSmsClient {

    @PostMapping(consumes = MediaType.APPLICATION_FORM_URLENCODED_VALUE)
    AliyunSmsSendResponse sendSms(@SpringQueryMap AliyunSmsSendRequest aliyunSmsSendRequest);
}
