package com.hncy.sms.spring.boot.starter.aliyun.client.config;

import com.hncy.sms.spring.boot.starter.aliyun.client.interceptor.AliyunSmsRequestInterceptor;
import com.hncy.sms.spring.boot.starter.constant.SmsConstant;
import feign.Request;
import feign.RequestInterceptor;
import org.springframework.context.annotation.Bean;

import java.util.concurrent.TimeUnit;

/**
 * @Author: ying.dong
 * @Date: 2021/5/11 19:33
 */
public class AliyunClientConfiguration {

    @Bean
    AliyunSmsRequestInterceptor aliyunSmsRequestInterceptor() {
        return new AliyunSmsRequestInterceptor();
    }

    @Bean
    Request.Options feignOptions() {
        return new Request.Options(SmsConstant.Timeout.DEFAULT_CONNECTION_TIMEOUT, TimeUnit.SECONDS,
                SmsConstant.Timeout.DEFAULT_READ_TIMEOUT, TimeUnit.SECONDS, true);
    }
}
