package com.hncy.sms.spring.boot.starter.aliyun.client.interceptor;

import feign.RequestInterceptor;
import feign.RequestTemplate;
import lombok.extern.slf4j.Slf4j;

import java.util.Collection;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @Author: ying.dong
 * @Date: 2021/5/12 14:01
 */
@Slf4j
public class AliyunSmsRequestInterceptor implements RequestInterceptor {
    @Override
    public void apply(RequestTemplate template) {
        Map<String, Collection<String>> queries = template.queries();
        if (queries == null || queries.isEmpty()) {
            return;
        }
        //reset parameters
        template.queries(null);
        Map<String, Collection<String>> parsedQueries = queries.entrySet()
                .stream().collect(Collectors.toMap(k -> firstCharUppercase(k.getKey()), Map.Entry::getValue));
        template.queries(parsedQueries);
        log.info("params replaced.....");
    }

    /**
     * 首字母转大写
     * @param original
     * @return
     */
    private String firstCharUppercase(String original) {
        return original.substring(0,1).toUpperCase().concat(original.substring(1));
    }
}
