package com.hncy.sms.spring.boot.starter.aliyun.response;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.hncy.sms.spring.boot.starter.core.response.SmsResponse;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;

/**
 * @Author: ying.dong
 * @Date: 2021/5/11 15:11
 */
@Data
@ToString(callSuper = true)
@EqualsAndHashCode(callSuper = true)
public class AliyunSmsSendResponse extends AliyunSmsBaseResponse implements SmsResponse {

    private static final String SUCCESS = "OK";

    /**
     * 发送回执ID
     */
    @JsonProperty("BizId")
    private String BizId;

    /**
     * 请求状态码(返回OK代表请求成功)
     */
    @JsonProperty("Code")
    private String Code;

    /**
     * 状态码的描述
     */
    @JsonProperty("Message")
    private String Message;

    @Override
    public boolean isSuccess() {
        return SUCCESS.equals(Code);
    }
}
