package com.hncy.common.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @author xuy
 * @date 09/06/2021.
 */
@Data
public class BaseEntityVo implements Serializable {

    private static final long serialVersionUID = 1354613091457930493L;

    private String id;

    /**
     * 修改时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date gmtModified;

    /***
     * 创建时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date gmtCreate;

    /***
     * 1:删除   0:不删除
     */
    private Integer deletedFlag = 0;


    /**
     * 创建者
     */
    private String createBy;


    /**
     * 更新者
     */
    private String updateBy;

    public static final String ID = "id";
    public static final String GMT_MODIFIED = "gmt_modified";
    public static final String GMT_CREATE = "gmt_create";
    public static final String DELETED_FLAG = "deleted_flag";
    public static final String CREATE_BY = "create_by";
    public static final String UPDATE_BY = "update_by";
}
