package com.hncy.common.exception.custom;

/**
 * @Author: ying.dong
 * @Date: 2021/4/19 16:24
 */
public class LocalAlarmBusinessException extends AlarmBusinessException implements Localizable {

    private static final long serialVersionUID = -8423987086879710458L;

    private int code;

    public LocalAlarmBusinessException(String message, Throwable cause) {
        super(message, cause);
    }

    public LocalAlarmBusinessException(int code) {
        super(code);
        this.code = code;
    }

    public LocalAlarmBusinessException(int code, Throwable cause) {
        super(cause);
        this.code = code;
    }

    public LocalAlarmBusinessException(int code, String message) {
        super(message);
        this.code = code;
    }
    public LocalAlarmBusinessException(int code, String message, Throwable cause) {
        super(message, cause);
        this.code = code;
    }
    public LocalAlarmBusinessException(String message) {
        super(message);
        this.code = -1;
    }

    public int getCode() {
        return code;
    }

    @Override
    public String getMessage() {
        return getLocalizedMessage() != null ? getLocalizedMessage() : super.getMessage();
    }

    @Override
    public String getLocalizedMessage() {
        return localize(code);
    }
}
