package ${package.Controller};

import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;
import com.hncy.common.dto.ResultBean;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import ${package.Entity}.${entity};
import ${package.Service}.${table.serviceName};
import org.springframework.beans.factory.annotation.Autowired;
import io.swagger.annotations.Api;
import java.util.List;

<#if restControllerStyle>
import org.springframework.web.bind.annotation.RestController;
<#else>
import org.springframework.stereotype.Controller;
</#if>
<#if superControllerClassPackage??>
import ${superControllerClassPackage};
</#if>

/**
* <p>
    * ${table.comment!}controller
    * </p>
*
* @author ${author}
* @since ${date}
*/
<#if restControllerStyle>
@RestController
<#else>
@Controller
</#if>
@RequestMapping("<#if package.ModuleName??>/${package.ModuleName}</#if>/<#if controllerMappingHyphenStyle??>${controllerMappingHyphen}<#else>${table.entityPath}</#if>")
<#if kotlin>
class ${table.controllerName}<#if superControllerClass??> : ${superControllerClass}()</#if>
<#else>
<#if superControllerClass??>
public class ${table.controllerName} extends ${superControllerClass} {
<#else>
@Slf4j
@Api(tags = "${table.comment!}")
public class ${table.controllerName} {
 </#if>

    @Autowired
    private ${table.serviceName} ${(table.serviceName)?uncap_first};

    @ApiOperation(value = "查询分页数据")
    @PostMapping(value = "/pagelist",produces = "application/json;charset=UTF-8")
    public ResultBean findListByPage(@ApiParam(name = "pageNum", value = "页码", required = true, defaultValue = "1")@RequestParam(name = "pageNum", defaultValue = "1") int pageNum,
                                     @ApiParam(name = "pageSize", value = "每页条数", required = true, defaultValue = "10")@RequestParam(name = "pageSize", defaultValue = "10") int pageSize){
           return null;
    }

    @ApiOperation(value = "根据id查询数据")
    @GetMapping(value = "/getById",produces = "application/json;charset=UTF-8")
    public ResultBean<${entity}> getById(@ApiParam(name = "id", value = "id", required = true)@RequestParam("id") String id){
        ${entity} ${entity?uncap_first} = ${(table.serviceName)?uncap_first}.getById(id);
        return ResultBean.success(${(table.entityName)?uncap_first});
    }

    @ApiOperation(value = "新增/修改数据")
    @PostMapping(value = "/saveAndUpdate", produces = "application/json;charset=UTF-8")
    public ResultBean<Void> saveAndUpdate(@ApiParam(name = "${entity?uncap_first}", value = "${entity}", required = true)@RequestBody ${entity} ${entity?uncap_first}){
        ${(table.serviceName)?uncap_first}.saveOrUpdate(${entity?uncap_first});
        return ResultBean.success();
    }

    @ApiOperation(value = "删除数据")
    @DeleteMapping(value = "/delByIds")
    public ResultBean<Void> delete(@ApiParam(name = "ids", value = "ID集合", required = true)@RequestParam("ids") List<String> ids){
        ${(table.serviceName)?uncap_first}.removeByIds(ids);
        return ResultBean.success();
    }
}
</#if>
