package com.hncy.service.wechat.applet.biz.controller;

import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;
import com.hncy.common.dto.ResultBean;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.hncy.service.wechat.applet.biz.entity.ComponentIssueReportRelation;
import com.hncy.service.wechat.applet.biz.service.ComponentIssueReportRelationService;
import org.springframework.beans.factory.annotation.Autowired;
import io.swagger.annotations.Api;
import java.util.List;

import org.springframework.web.bind.annotation.RestController;

/**
* <p>
    * 部件和上报案件关系controller
    * </p>
*
* @author cs
* @since 2021-11-02
*/
@RestController
@RequestMapping("/component-issue-report-relation")
@Slf4j
@Api(tags = "部件和上报案件关系")
public class ComponentIssueReportRelationController {

    @Autowired
    private ComponentIssueReportRelationService componentIssueReportRelationService;

    @ApiOperation(value = "查询分页数据")
    @PostMapping(value = "/pagelist",produces = "application/json;charset=UTF-8")
    public ResultBean findListByPage(@ApiParam(name = "pageNum", value = "页码", required = true, defaultValue = "1")@RequestParam(name = "pageNum", defaultValue = "1") int pageNum,
                                     @ApiParam(name = "pageSize", value = "每页条数", required = true, defaultValue = "10")@RequestParam(name = "pageSize", defaultValue = "10") int pageSize){
           return null;
    }

    @ApiOperation(value = "根据id查询数据")
    @GetMapping(value = "/getById",produces = "application/json;charset=UTF-8")
    public ResultBean<ComponentIssueReportRelation> getById(@ApiParam(name = "id", value = "id", required = true)@RequestParam("id") String id){
        ComponentIssueReportRelation componentIssueReportRelation = componentIssueReportRelationService.getById(id);
        return ResultBean.success(componentIssueReportRelation);
    }

    @ApiOperation(value = "新增/修改数据")
    @PostMapping(value = "/saveAndUpdate", produces = "application/json;charset=UTF-8")
    public ResultBean<Void> saveAndUpdate(@ApiParam(name = "componentIssueReportRelation", value = "ComponentIssueReportRelation", required = true)@RequestBody ComponentIssueReportRelation componentIssueReportRelation){
        componentIssueReportRelationService.saveOrUpdate(componentIssueReportRelation);
        return ResultBean.success();
    }

    @ApiOperation(value = "删除数据")
    @DeleteMapping(value = "/delByIds")
    public ResultBean<Void> delete(@ApiParam(name = "ids", value = "ID集合", required = true)@RequestParam("ids") List<String> ids){
        componentIssueReportRelationService.removeByIds(ids);
        return ResultBean.success();
    }
}
