package com.hncy.service.wechat.applet.biz.controller;

import com.hncy.service.wechat.applet.biz.vo.ComponentSubTypesVo;
import com.hncy.service.wechat.applet.biz.vo.ComponentTypesVo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;
import com.hncy.common.dto.ResultBean;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.hncy.service.wechat.applet.biz.entity.ComponentType;
import com.hncy.service.wechat.applet.biz.service.ComponentTypeService;
import org.springframework.beans.factory.annotation.Autowired;
import io.swagger.annotations.Api;
import java.util.List;

import org.springframework.web.bind.annotation.RestController;

/**
* <p>
    * 部件类型controller
    * </p>
*
* @author cs
* @since 2021-11-02
*/
@RestController
@RequestMapping("/component-type")
@Slf4j
@Api(tags = "部件类型")
public class ComponentTypeController {

    @Autowired
    private ComponentTypeService componentTypeService;

/*    @ApiOperation(value = "获取城市部件类型以及立案条件（内部调用）")
    @GetMapping(value = "/getComponentTypeAndRegCondByCtiySys")
    ResultBean getComponentTypeAndRegCondByCtiySys() {
        return componentTypeService.getComponentTypeAndRegCondByCtiySys();
    }*/

    @ApiOperation(value = "下拉框获取所有部件类型")
    @PostMapping(value = "/selectAllTypes")
    ResultBean<List<ComponentTypesVo>> selectAllTypes() {
        return componentTypeService.selectAllTypes();
    }

    @ApiOperation(value = "根据部件类别查询所有部件的子类")
    @PostMapping(value = "/selectAllTypesBySub")
    ResultBean<List<ComponentSubTypesVo>> selectAllTypesBySub(@ApiParam(name = "componentSuperName",value = "部件父类名称：市容环境，公用设施，拓展部件",required = true) @RequestParam("componentSuperName") String componentSuperName,
                                                              @ApiParam(name = "componentSuperCode",value = "部件父类编码：003,001,021",required = true) @RequestParam("componentSuperCode") String componentSuperCode,
                                                              @ApiParam(name = "componentTypeName",value = "部件类型名称：垃圾箱，井盖",required = true) @RequestParam("componentTypeName") String componentTypeName,
                                                              @ApiParam(name = "componentTypeCode",value = "部件代码代码：1,2",required = true) @RequestParam("componentTypeCode") String componentTypeCode) {
        return componentTypeService.selectAllTypesBySub(componentSuperName,componentSuperCode,componentTypeCode,componentTypeName);
    }



}
