package com.hncy.service.wechat.applet.biz.entity;

import java.time.LocalDateTime;
import com.hncy.common.base.BaseEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 部件详情
 * </p>
 *
 * @author cs
 * @since 2021-11-02
 */
@Data
@EqualsAndHashCode(callSuper = true)
@ApiModel(value="ComponentDetail对象", description="部件详情")
public class ComponentDetail extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "部件父类名称：市容环境，公用设施，拓展部件")
    private String componentSuperName;

    @ApiModelProperty(value = "部件父类编码：003,001,021")
    private String componentSuperCode;

    @ApiModelProperty(value = "部件类型名称：垃圾桶，井盖")
    private String componentTypeName;

    @ApiModelProperty(value = "部件代码代码：1,2")
    private String componentTypeCode;

    @ApiModelProperty(value = "部件子类名称：如雨水井盖之类")
    private String componentName;

    @ApiModelProperty(value = "部件子类编码")
    private String componentCode;

    @ApiModelProperty(value = "部件标识")
    private String componentLogo;

    @ApiModelProperty(value = "部件详细地址")
    private String componentAddress;

    @ApiModelProperty(value = "部件位置经度")
    private String xCode;

    @ApiModelProperty(value = "部件位置纬度")
    private String yCode;

    @ApiModelProperty(value = "巡检时间")
    private LocalDateTime patrolInspectionTime;

    @ApiModelProperty(value = "部件采集方式:1.部件采集 2.问题上报")
    private String componentCollectionWays;


    public static final String COMPONENT_SUPER_NAME = "component_super_name";

    public static final String COMPONENT_SUPER_CODE = "component_super_code";

    public static final String COMPONENT_TYPE_NAME = "component_type_name";

    public static final String COMPONENT_TYPE_CODE = "component_type_code";

    public static final String COMPONENT_NAME = "component_name";

    public static final String COMPONENT_CODE = "component_code";

    public static final String COMPONENT_LOGO = "component_logo";

    public static final String COMPONENT_ADDRESS = "component_address";

    public static final String X_CODE = "x_code";

    public static final String Y_CODE = "y_code";

    public static final String PATROL_INSPECTION_TIME = "patrol_inspection_time";

    public static final String COMPONENT_COLLECTION_WAYS = "component_collection_ways";

}
