package com.hncy.service.wechat.applet.biz.entity;

import com.hncy.common.base.BaseEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 部件问题上报
 * </p>
 *
 * @author cs
 * @since 2021-11-02
 */
@Data
@EqualsAndHashCode(callSuper = true)
@ApiModel(value="ComponentIssuesReport对象", description="部件问题上报")
public class ComponentIssuesReport extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "部件上报案件条件编码")
    private String regCondCode;

    @ApiModelProperty(value = "部件上报案件条件名称")
    private String regCondName;

    @ApiModelProperty(value = "部件上报案件描述情况")
    private String issueDescription;

    @ApiModelProperty(value = "上报部件代码")
    private String componentReportCode;

    @ApiModelProperty(value = "上报部件名称")
    private String componentReportName;


    public static final String REG_COND_CODE = "reg_cond_code";

    public static final String REG_COND_NAME = "reg_cond_name";

    public static final String ISSUE_DESCRIPTION = "issue_description";

    public static final String COMPONENT_REPORT_CODE = "component_report_code";

    public static final String COMPONENT_REPORT_NAME = "component_report_name";

}
