package com.hncy.service.wechat.applet.biz.entity;

import com.hncy.common.base.BaseEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 部件类型
 * </p>
 *
 * @author cs
 * @since 2021-11-02
 */
@Data
@EqualsAndHashCode(callSuper = true)
@ApiModel(value="ComponentType对象", description="部件类型")
public class ComponentType extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "部件父类名称：市容环境，公用设施，拓展部件")
    private String componentSuperName;

    @ApiModelProperty(value = "部件父类编码：003,001,021")
    private String componentSuperCode;

    @ApiModelProperty(value = "部件子类名称：如雨水井盖之类")
    private String componentName;

    @ApiModelProperty(value = "部件子类编码")
    private String componentCode;


    public static final String COMPONENT_SUPER_NAME = "component_super_name";

    public static final String COMPONENT_SUPER_CODE = "component_super_code";

    public static final String COMPONENT_NAME = "component_name";

    public static final String COMPONENT_CODE = "component_code";

}
