package com.hncy.service.wechat.applet.biz.entity;

import java.time.LocalDateTime;
import com.hncy.common.base.BaseEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 微信小程序用户表
 * </p>
 *
 * @author cs
 * @since 2021-10-27
 */
@Data
@EqualsAndHashCode(callSuper = true)
@ApiModel(value="WxUser对象", description="微信小程序用户表")
public class WxUser extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "微信对应小程序唯一识别号")
    private String openId;

    @ApiModelProperty(value = "头像相对路径")
    private String avatar;

    @ApiModelProperty(value = "昵称")
    private String nickname;

    @ApiModelProperty(value = "1：男，2：女")
    private String sexCode;

    @ApiModelProperty(value = "男，女")
    private String sexName;

    @ApiModelProperty(value = "手机号")
    private String tel;

    @ApiModelProperty(value = "最近登录时间")
    private LocalDateTime loginDate;

    @ApiModelProperty(value = "用户在开放平台的唯一标识符")
    private String unionId;

    @ApiModelProperty(value = "微信用户对应角色")
    private String role;


    public static final String OPEN_ID = "open_id";

    public static final String AVATAR = "avatar";

    public static final String NICKNAME = "nickname";

    public static final String SEX_CODE = "sex_code";

    public static final String SEX_NAME = "sex_name";

    public static final String TEL = "tel";

    public static final String LOGIN_DATE = "login_date";

    public static final String UNION_ID = "union_id";

    public static final String ROLE = "role";

}
