package com.hncy.service.wechat.applet.biz.mapper;

import com.hncy.service.wechat.applet.biz.dto.CountMounthComponentDto;
import com.hncy.service.wechat.applet.biz.entity.ComponentDetail;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.hncy.service.wechat.applet.biz.vo.ComponentDetailVo;
import com.hncy.service.wechat.applet.biz.vo.ComponentSubTypesVo;
import com.hncy.service.wechat.applet.biz.vo.ComponentTypesVo;
import com.hncy.service.wechat.applet.biz.vo.CountMonthComponentsVo;
import org.apache.ibatis.annotations.Param;

import java.time.LocalDateTime;
import java.util.List;

/**
 * <p>
 * 部件详情 Mapper 接口
 * </p>
 *
 * @author cs
 * @since 2021-11-02
 */
public interface ComponentDetailMapper extends BaseMapper<ComponentDetail> {

    List<ComponentDetail> selectBySubClassName(@Param("componentName") String subClassName);

    ComponentDetail selectBySubClassNameAndsubClassCode(@Param("componentCode") String subClassCode, @Param("componentName") String subClassName);

    List<ComponentDetailVo> judgeAIComponentIsExist(@Param("componentTypeName") String componentTypeName, @Param("xCode") String xCode, @Param("yCode") String yCode);

    List<ComponentTypesVo> selectAllTypes();

    List<ComponentSubTypesVo> selectAllTypesBySub(@Param("componentSuperName") String componentSuperName, @Param("componentSuperCode") String componentSuperCode,@Param("componentTypeCode") String componentTypeCode, @Param("componentTypeName") String componentTypeName);

    String selectTodaySum();

    String selectTodayComponentsSum();

    List<ComponentDetail> selectTodayComponentsTypeSum();

    int savepatrolInspectionTime(@Param("patrolInspectionTime") LocalDateTime patrolInspectionTime, @Param("componentLogo") String componentLogo);


    List<CountMounthComponentDto> selectSumComponentsByMounth();

}
