package com.hncy.service.wechat.applet.biz.mini.common.store;

import com.hncy.redis.spring.boot.starter.core.RedisRepository;

/**
 * @Author: ying.dong
 * @Date: 2021/6/15 15:55
 */
public class RedisAccessTokenStore implements AccessTokenStore {

    private final String key;
    private final long exipreInSeconds;
    private final RedisRepository<String> redisRepository;

    public RedisAccessTokenStore(String key, long exipreInSeconds, RedisRepository<String> redisRepository) {
        this.key = key;
        this.exipreInSeconds = exipreInSeconds;
        this.redisRepository = redisRepository;
    }

    @Override
    public String getAccessToken() {
        return redisRepository.get(key);
    }

    @Override
    public void store(String accessToken) {
        redisRepository.setEx(key, accessToken, exipreInSeconds);
    }
}
