package com.hncy.service.wechat.applet.biz.mini.constant;

/**
 * @Author: ying.dong
 * @Date: 2021/6/15 15:28
 */
public interface MiniProgramConstant {

    /**
     * 默认连接超时时间（2S）
     */
    long DEFAULT_CONNECTION_TIMEOUT = 2;

    /**
     * 默认超时时间(3S)
     */
    long DEFAULT_READ_TIMEOUT = 3;

    /**
     * 地址
     */
    String DOMAIN = "https://api.weixin.qq.com/";

    /**
     * Feign包地址
     */
    String CLIENT_PACKAGE = "com.hncy.service.wechat.applet.biz.mini.feign";

    /**
     * client 名
     */
    interface FeignClientName {
        String SNS_FEIGN_CLIENT = "mini-program-original-feign-client";
    }

    /**
     * API相关
     */
    interface API {

        interface SNS {
            String CODE2SESSION = "/sns/jscode2session";
        }

        interface TOKEN {
            String ACCESS_TOKEN = "/cgi-bin/token";
        }

        interface MESSAGE {
            /**
             * 发送订阅消息
             */
            String SUBSCRIBE = "/cgi-bin/message/subscribe/send";
        }
    }
}
