package com.hncy.service.wechat.applet.biz.mini.dto.input;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.lang.NonNull;
import org.springframework.lang.Nullable;

import java.util.Map;

/**
 * @Author: ying.dong
 * @Date: 2021/6/18 10:19
 */
@Data
@NoArgsConstructor
@JsonInclude(JsonInclude.Include.NON_NULL)
public class SubscribeMessageInput {

    @NonNull
    @JsonProperty("access_token")
    private String accessToken;

    /**
     * 接收者（用户）的 openid
     * 必填
     */
    @NonNull
    @JsonProperty("touser")
    private String openId;

    /**
     * 模板ID
     * 必填
     */
    @NonNull
    @JsonProperty("template_id")
    private String templateId;

    /**
     * 点击模板卡片后的跳转页面，仅限本小程序内的页面。支持带参数,（示例index?foo=bar）。该字段不填则模板无跳转。
     * 非必填
     */
    @Nullable
    private String page;

    /**
     * 模板内容，格式形如 { "key1": { "value": any }, "key2": { "value": any } }
     * 必填
     */
    @NonNull
    private Map<String, Object> data;

    /**
     * 跳转小程序类型：developer为开发版；trial为体验版；formal为正式版；默认为正式版
     * 非必填
     */
    @Nullable
    @JsonProperty("miniprogram_state")
    private String miniprogramState;

    /**
     * 进入小程序查看”的语言类型，支持zh_CN(简体中文)、en_US(英文)、zh_HK(繁体中文)、zh_TW(繁体中文)，默认为zh_CN
     * 非必填
     */
    @Nullable
    private String lang;
}
