package com.hncy.service.wechat.applet.biz.mini.feign;

import com.hncy.service.wechat.applet.api.dto.output.BaseOutput;
import com.hncy.service.wechat.applet.api.dto.output.Code2SessionOutput;
import com.hncy.service.wechat.applet.biz.mini.config.MiniProgramClientConfiguration;
import com.hncy.service.wechat.applet.biz.mini.constant.MiniProgramConstant;
import com.hncy.service.wechat.applet.biz.mini.dto.input.AccessTokenInput;
import com.hncy.service.wechat.applet.biz.mini.dto.input.Code2SessionInput;
import com.hncy.service.wechat.applet.biz.mini.dto.input.SubscribeMessageInput;
import com.hncy.service.wechat.applet.biz.mini.dto.out.AccessTokenOutput;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.cloud.openfeign.SpringQueryMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

/**
 * @Author: ying.dong
 * @Date: 2021/6/15 15:28
 */
@FeignClient(name = MiniProgramConstant.FeignClientName.SNS_FEIGN_CLIENT, url = MiniProgramConstant.DOMAIN, configuration = MiniProgramClientConfiguration.class)
public interface MiniProgramOriginalFeignClient {

    @GetMapping(value = MiniProgramConstant.API.SNS.CODE2SESSION)
    Code2SessionOutput login(@SpringQueryMap Code2SessionInput input);

    @GetMapping(value = MiniProgramConstant.API.TOKEN.ACCESS_TOKEN)
    AccessTokenOutput getAccessToken(@SpringQueryMap AccessTokenInput accessTokenInput);

    @PostMapping(MiniProgramConstant.API.MESSAGE.SUBSCRIBE)
    BaseOutput sendSubscribeMessage(@RequestBody SubscribeMessageInput input, @RequestParam("access_token")String accessToken);
}
