package com.hncy.service.wechat.applet.biz.service.impl;

import com.hncy.common.dto.ResultBean;
import com.hncy.service.wechat.applet.biz.entity.ComponentDetail;
import com.hncy.service.wechat.applet.biz.entity.ComponentIssueReportRelation;
import com.hncy.service.wechat.applet.biz.entity.ComponentIssuesReport;
import com.hncy.service.wechat.applet.biz.entity.ComponentType;
import com.hncy.service.wechat.applet.biz.mapper.ComponentDetailMapper;
import com.hncy.service.wechat.applet.biz.mapper.ComponentIssuesReportMapper;
import com.hncy.service.wechat.applet.biz.mapper.ComponentTypeMapper;
import com.hncy.service.wechat.applet.biz.service.ComponentTypeService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.hncy.service.wechat.applet.biz.service.ComponentsRemoteService;
import com.hncy.service.wechat.applet.biz.vo.ComponentSubTypesVo;
import com.hncy.service.wechat.applet.biz.vo.ComponentTypesVo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 部件类型 服务实现类
 * </p>
 *
 * @author cs
 * @since 2021-11-02
 */
@Service
@Slf4j
public class ComponentTypeServiceImpl extends ServiceImpl<ComponentTypeMapper, ComponentType> implements ComponentTypeService {

    @Autowired
    private ComponentsRemoteService componentsRemoteService;
    @Autowired
    private ComponentTypeMapper componentTypeMapper;
    @Autowired
    private ComponentIssuesReportMapper componentIssuesReportMapper;
    @Autowired
    private ComponentDetailMapper componentDetailMapper;

    @Override
    public ResultBean getComponentTypeAndRegCondByCtiySys() {
        Map<String, Object> stringObjectMap = componentsRemoteService.queryTypeAndRegCond();
        //部门大小类
        List<Map<String,String>> typeLists = (List<Map<String, String>>) stringObjectMap.get("typeList");
        for(Map<String,String> typeList : typeLists) {
            String subClassName = typeList.get("subClassName");
            String subClassCode = typeList.get("subClassCode");
            String bigClassName = typeList.get("bigClassName");
            String bigClassCode = typeList.get("bigClassCode");

            ComponentType componentType = new ComponentType();
            componentType.setComponentCode(subClassCode);
            componentType.setComponentName(subClassName);
            componentType.setComponentSuperCode(bigClassCode);
            componentType.setComponentSuperCode(bigClassName);
            componentTypeMapper.insert(componentType);
        }
        //上报问题案件类型
        List<Map<String,String>> regCondLists = (List<Map<String, String>>) stringObjectMap.get("regCondList");
        for (Map<String,String> regCondList : regCondLists) {
            String subClassCode = regCondList.get("subClassCode");
            String subClassName = regCondList.get("subClassName");
            String regCondCode = regCondList.get("regCondCode");
            String regCondName = regCondList.get("regCondName");
            ComponentIssuesReport componentIssuesReport = new ComponentIssuesReport();
            componentIssuesReport.setRegCondCode(regCondCode);
            componentIssuesReport.setRegCondName(regCondName);
            componentIssuesReport.setComponentReportCode(subClassCode);
            componentIssuesReport.setComponentReportName(subClassName);
            componentIssuesReportMapper.insert(componentIssuesReport);
        }
        return ResultBean.success();
    }

    @Override
    public ResultBean<List<ComponentTypesVo>> selectAllTypes() {
        List<ComponentTypesVo> componentTypesVos  = componentDetailMapper.selectAllTypes();
        log.info(componentTypesVos.toString());
        return ResultBean.success(componentTypesVos);
    }

    @Override
    public ResultBean<List<ComponentSubTypesVo>> selectAllTypesBySub(String componentSuperName, String componentSuperCode, String componentTypeCode, String componentTypeName) {
        log.info("componentSuperName"+componentSuperName);
        log.info("componentSuperCode"+componentSuperCode);
        List<ComponentSubTypesVo> componentSubTypesVos = componentDetailMapper.selectAllTypesBySub(componentSuperName,componentSuperCode,componentTypeCode,componentTypeName);
        log.info(componentSubTypesVos.toString());
        return ResultBean.success(componentSubTypesVos);
    }
}
