package com.hncy.service.wechat.applet.biz.service.impl;

import com.hncy.common.dto.ResultBean;
import com.hncy.pageable.spring.boot.starter.core.Page;
import com.hncy.service.wechat.applet.biz.entity.*;
import com.hncy.service.wechat.applet.biz.mapper.*;
import com.hncy.service.wechat.applet.biz.service.PlatformAuditService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.hncy.service.wechat.applet.biz.vo.AuditComponentVo;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 平台端审核表 服务实现类
 * </p>
 *
 * @author cs
 * @since 2021-11-04
 */
@Service
public class PlatformAuditServiceImpl extends ServiceImpl<PlatformAuditMapper, PlatformAudit> implements PlatformAuditService {

    @Autowired
    private PlatformAuditMapper platformAuditMapper;
    @Autowired
    private ComponentDetailMapper componentDetailMapper;
    @Autowired
    private ComponentIssuesReportMapper componentIssuesReportMapper;
    @Autowired
    private ComponentIssueReportRelationMapper componentIssueReportRelationMapper;
    @Autowired
    private ComponentPictureMapper componentPictureMapper;
    @Autowired
    private ComponentPictureRelationMapper componentPictureRelationMapper;

    @Override
    public ResultBean<Page<PlatformAudit>> searchPlatformAuditlist(int pageNum, int pageSize, String auditStatus) {
        Page<PlatformAudit> platformAuditPage =Page.doSelectPage(() ->platformAuditMapper.searchPlatformAuditlist(auditStatus));
        return ResultBean.success(platformAuditPage);

    }

    @Override
    public ResultBean<AuditComponentVo> selectDetailAudit(String id, String componentDetailId, String componentIssuesReportId) {
        List<String> pictureUrls = new ArrayList<>();
        PlatformAudit platformAudit = platformAuditMapper.selectById(id);
        ComponentDetail componentDetail = componentDetailMapper.selectById(componentDetailId);
        ComponentIssuesReport componentIssuesReport = componentIssuesReportMapper.selectById(componentIssuesReportId);
        AuditComponentVo auditComponentVo = new AuditComponentVo();

        auditComponentVo.setRegCondCode(componentIssuesReport.getRegCondCode());
        auditComponentVo.setRegCondName(componentIssuesReport.getRegCondName());
        auditComponentVo.setIssueDescription(componentIssuesReport.getIssueDescription());
        auditComponentVo.setComponentSuperName(componentDetail.getComponentSuperName());
        auditComponentVo.setComponentSuperCode(componentDetail.getComponentSuperCode());
        auditComponentVo.setComponentTypeName(componentDetail.getComponentTypeName());
        auditComponentVo.setComponentTypeCode(componentDetail.getComponentCode());
        auditComponentVo.setComponentName(componentDetail.getComponentName());
        auditComponentVo.setComponentCode(componentDetail.getComponentCode());
        auditComponentVo.setComponentLogo(componentDetail.getComponentLogo());
        auditComponentVo.setComponentAddress(componentDetail.getComponentAddress());
        auditComponentVo.setReporter(componentDetail.getCreateBy());
        auditComponentVo.setReportTime(componentDetail.getGmtCreate());
        auditComponentVo.setAuditTime(platformAudit.getAuditTime());
        auditComponentVo.setAuditStatus(platformAudit.getAuditStatus());
        List<ComponentPictureRelation> componentPictureRelationList = componentPictureRelationMapper.selectDetailAudit(componentDetailId);
        componentPictureRelationList.stream().forEach(componentPictureRelation -> {
            String pictureId = componentPictureRelation.getComponentPictureId();
            ComponentPicture componentPicture = componentPictureMapper.selectById(pictureId);
            String url = componentPicture.getComponentPictureUrl();
            pictureUrls.add(url);
        });
        auditComponentVo.setPictureUrls(pictureUrls);
        return ResultBean.success(auditComponentVo);
    }


}
